<html>
<head>
<title>OgreGLFBORenderTexture.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_43d9b0265a5a2fd53bf3892a292ce5e9.html">RenderSystems</a>      </li>
      <li class="navelem"><a class="el" href="dir_5bc5f2f46c6364f2594540d45df3d051.html">GL</a>      </li>
      <li class="navelem"><a class="el" href="dir_f7b8a29f58b064e3a63f570f2fc89729.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreGLFBORenderTexture.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreGLFBORenderTexture_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __OgreGLFBORTT_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __OgreGLFBORTT_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgreGLRenderTexture_8h.html">OgreGLRenderTexture.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreGLContext_8h.html">OgreGLContext.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreGLFrameBufferObject_8h.html">OgreGLFrameBufferObject.h</a>&quot;</span>
<a name="l00034"></a>00034 
<a name="l00036"></a><a class="code" href="OgreGLFBORenderTexture_8h.html#a977d93453dbd8b304989cbd9b1606490">00036</a> <span class="preprocessor">#define GL_DEPTH24_STENCIL8_EXT                           0x88F0</span>
<a name="l00037"></a>00037 <span class="preprocessor"></span>
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 <span class="keyword">namespace </span>Ogre {
<a name="l00040"></a>00040     <span class="keyword">class </span>GLFBOManager;
<a name="l00041"></a>00041 
<a name="l00044"></a><a class="code" href="classOgre_1_1GLFBORenderTexture.html">00044</a>     <span class="keyword">class </span><a class="code" href="OgreGLPrerequisites_8h.html#a84aebcce92aa9d20cdb06ab0eab6b1f8" title="Lots of generated code in here which triggers the new VC CRT security warnings.">_OgreGLExport</a> <a class="code" href="classOgre_1_1GLFBORenderTexture.html" title="RenderTexture for GL FBO.">GLFBORenderTexture</a>: <span class="keyword">public</span> <a class="code" href="classOgre_1_1GLRenderTexture.html" title="Base class for GL Render Textures.">GLRenderTexture</a>
<a name="l00045"></a>00045     {
<a name="l00046"></a>00046     <span class="keyword">public</span>:
<a name="l00047"></a>00047         <a class="code" href="classOgre_1_1GLFBORenderTexture.html" title="RenderTexture for GL FBO.">GLFBORenderTexture</a>(<a class="code" href="classOgre_1_1GLFBOManager.html" title="Factory for GL Frame Buffer Objects, and related things.">GLFBOManager</a> *manager, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;name, <span class="keyword">const</span> <a class="code" href="structOgre_1_1GLSurfaceDesc.html" title="GL surface descriptor.">GLSurfaceDesc</a> &amp;target, <span class="keywordtype">bool</span> writeGamma, <a class="code" href="namespaceOgre.html#ab6e842a18caf062ed73a5d3badd0dd4c">uint</a> fsaa);
<a name="l00048"></a>00048 
<a name="l00049"></a>00049         <span class="keyword">virtual</span> <span class="keywordtype">void</span> getCustomAttribute(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <span class="keywordtype">void</span>* pData);
<a name="l00050"></a>00050 
<a name="l00052"></a>00052         <span class="keyword">virtual</span> <span class="keywordtype">void</span> swapBuffers(<span class="keywordtype">bool</span> waitForVSync = <span class="keyword">true</span>);
<a name="l00053"></a>00053 
<a name="l00055"></a>00055         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> attachDepthBuffer( <a class="code" href="classOgre_1_1DepthBuffer.html" title="An abstract class that contains a depth/stencil buffer.">DepthBuffer</a> *depthBuffer );
<a name="l00056"></a>00056         <span class="keyword">virtual</span> <span class="keywordtype">void</span> detachDepthBuffer();
<a name="l00057"></a>00057         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _detachDepthBuffer();
<a name="l00058"></a>00058     <span class="keyword">protected</span>:
<a name="l00059"></a><a class="code" href="classOgre_1_1GLFBORenderTexture.html#a892b0254ed1720d66406209cdfd4cf7d">00059</a>         <a class="code" href="classOgre_1_1GLFrameBufferObject.html" title="Frame Buffer Object abstraction.">GLFrameBufferObject</a> <a class="code" href="classOgre_1_1GLFBORenderTexture.html#a892b0254ed1720d66406209cdfd4cf7d">mFB</a>;
<a name="l00060"></a>00060     };
<a name="l00061"></a>00061     
<a name="l00064"></a><a class="code" href="classOgre_1_1GLFBOManager.html">00064</a>     <span class="keyword">class </span><a class="code" href="OgreGLPrerequisites_8h.html#a84aebcce92aa9d20cdb06ab0eab6b1f8" title="Lots of generated code in here which triggers the new VC CRT security warnings.">_OgreGLExport</a> <a class="code" href="classOgre_1_1GLFBOManager.html" title="Factory for GL Frame Buffer Objects, and related things.">GLFBOManager</a>: <span class="keyword">public</span> <a class="code" href="classOgre_1_1GLRTTManager.html" title="Manager/factory for RenderTextures.">GLRTTManager</a>
<a name="l00065"></a>00065     {
<a name="l00066"></a>00066     <span class="keyword">public</span>:
<a name="l00067"></a>00067         <a class="code" href="classOgre_1_1GLFBOManager.html" title="Factory for GL Frame Buffer Objects, and related things.">GLFBOManager</a>(<span class="keywordtype">bool</span> atimode);
<a name="l00068"></a>00068         ~<a class="code" href="classOgre_1_1GLFBOManager.html" title="Factory for GL Frame Buffer Objects, and related things.">GLFBOManager</a>();
<a name="l00069"></a>00069         
<a name="l00073"></a>00073         <span class="keywordtype">void</span> bind(<a class="code" href="classOgre_1_1RenderTarget.html" title="A &#39;canvas&#39; which can receive the results of a rendering operation.">RenderTarget</a> *target);
<a name="l00074"></a>00074         
<a name="l00077"></a><a class="code" href="classOgre_1_1GLFBOManager.html#aa17c48a8227a5428e39a750e9fe9eda6">00077</a>         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1GLFBOManager.html#aa17c48a8227a5428e39a750e9fe9eda6" title="Unbind a certain render target.">unbind</a>(<a class="code" href="classOgre_1_1RenderTarget.html" title="A &#39;canvas&#39; which can receive the results of a rendering operation.">RenderTarget</a> *target) {};
<a name="l00078"></a>00078         
<a name="l00081"></a>00081         <span class="keywordtype">void</span> getBestDepthStencil(GLenum internalFormat, GLenum *depthFormat, GLenum *stencilFormat);
<a name="l00082"></a>00082         
<a name="l00085"></a>00085         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1GLFBORenderTexture.html" title="RenderTexture for GL FBO.">GLFBORenderTexture</a> *createRenderTexture(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;name, 
<a name="l00086"></a>00086             <span class="keyword">const</span> <a class="code" href="structOgre_1_1GLSurfaceDesc.html" title="GL surface descriptor.">GLSurfaceDesc</a> &amp;target, <span class="keywordtype">bool</span> writeGamma, <a class="code" href="namespaceOgre.html#ab6e842a18caf062ed73a5d3badd0dd4c">uint</a> fsaa);
<a name="l00087"></a>00087 
<a name="l00090"></a>00090         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1MultiRenderTarget.html" title="This class represents a render target that renders to multiple RenderTextures at once.">MultiRenderTarget</a>* createMultiRenderTarget(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp; name);
<a name="l00091"></a>00091         
<a name="l00094"></a>00094         <a class="code" href="structOgre_1_1GLSurfaceDesc.html" title="GL surface descriptor.">GLSurfaceDesc</a> requestRenderBuffer(GLenum format, <span class="keywordtype">size_t</span> width, <span class="keywordtype">size_t</span> height, <a class="code" href="namespaceOgre.html#ab6e842a18caf062ed73a5d3badd0dd4c">uint</a> fsaa);
<a name="l00098"></a>00098         <span class="keywordtype">void</span> requestRenderBuffer(<span class="keyword">const</span> <a class="code" href="structOgre_1_1GLSurfaceDesc.html" title="GL surface descriptor.">GLSurfaceDesc</a> &amp;surface);
<a name="l00101"></a>00101         <span class="keywordtype">void</span> releaseRenderBuffer(<span class="keyword">const</span> <a class="code" href="structOgre_1_1GLSurfaceDesc.html" title="GL surface descriptor.">GLSurfaceDesc</a> &amp;surface);
<a name="l00102"></a>00102         
<a name="l00105"></a><a class="code" href="classOgre_1_1GLFBOManager.html#a8a95d8f7f7aedd2c70b2c9fe546528f1">00105</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1GLFBOManager.html#a8a95d8f7f7aedd2c70b2c9fe546528f1" title="Check if a certain format is usable as FBO rendertarget format.">checkFormat</a>(<a class="code" href="group__Image.html#ga7e0353e7d36d4c2e8468641b7303d39c" title="The pixel format used for images, textures, and render surfaces.">PixelFormat</a> format) { <span class="keywordflow">return</span> mProps[format].valid; }
<a name="l00106"></a>00106         
<a name="l00109"></a><a class="code" href="classOgre_1_1GLFBOManager.html#a86e8f0bc503e0c160a01258be0bc8e8b">00109</a>         GLuint <a class="code" href="classOgre_1_1GLFBOManager.html#a86e8f0bc503e0c160a01258be0bc8e8b" title="Get a FBO without depth/stencil for temporary use, like blitting between textures.">getTemporaryFBO</a>() { <span class="keywordflow">return</span> mTempFBO; }
<a name="l00110"></a>00110     <span class="keyword">private</span>:
<a name="l00113"></a><a class="code" href="structOgre_1_1GLFBOManager_1_1FormatProperties.html">00113</a>         <span class="keyword">struct </span><a class="code" href="structOgre_1_1GLFBOManager_1_1FormatProperties.html" title="Frame Buffer Object properties for a certain texture format.">FormatProperties</a>
<a name="l00114"></a>00114         {
<a name="l00115"></a><a class="code" href="structOgre_1_1GLFBOManager_1_1FormatProperties.html#a6ef6e0ff7fc517809ecaf656a4f32d50">00115</a>             <span class="keywordtype">bool</span> <a class="code" href="structOgre_1_1GLFBOManager_1_1FormatProperties.html#a6ef6e0ff7fc517809ecaf656a4f32d50">valid</a>; <span class="comment">// This format can be used as RTT (FBO)</span>
<a name="l00116"></a>00116             
<a name="l00119"></a><a class="code" href="structOgre_1_1GLFBOManager_1_1FormatProperties_1_1Mode.html">00119</a>             <span class="keyword">struct </span><a class="code" href="structOgre_1_1GLFBOManager_1_1FormatProperties_1_1Mode.html" title="Allowed modes/properties for this pixel format.">Mode</a>
<a name="l00120"></a>00120             {
<a name="l00121"></a><a class="code" href="structOgre_1_1GLFBOManager_1_1FormatProperties_1_1Mode.html#a6d6cea381ba3087e149c7f31e62a3450">00121</a>                 <span class="keywordtype">size_t</span> <a class="code" href="structOgre_1_1GLFBOManager_1_1FormatProperties_1_1Mode.html#a6d6cea381ba3087e149c7f31e62a3450">depth</a>;     <span class="comment">// Depth format (0=no depth)</span>
<a name="l00122"></a><a class="code" href="structOgre_1_1GLFBOManager_1_1FormatProperties_1_1Mode.html#ae9d1688841f6555a52015cf257970b45">00122</a>                 <span class="keywordtype">size_t</span> <a class="code" href="structOgre_1_1GLFBOManager_1_1FormatProperties_1_1Mode.html#ae9d1688841f6555a52015cf257970b45">stencil</a>;   <span class="comment">// Stencil format (0=no stencil)</span>
<a name="l00123"></a>00123             };
<a name="l00124"></a>00124             
<a name="l00125"></a><a class="code" href="structOgre_1_1GLFBOManager_1_1FormatProperties.html#a633b3871eec55f1afe8b982167b5cbcd">00125</a>             <a class="code" href="structOgre_1_1vector.html">vector&lt;Mode&gt;::type</a> <a class="code" href="structOgre_1_1GLFBOManager_1_1FormatProperties.html#a633b3871eec55f1afe8b982167b5cbcd">modes</a>;
<a name="l00126"></a>00126         };
<a name="l00129"></a><a class="code" href="classOgre_1_1GLFBOManager.html#af3aacbf298934f4eff3a6c3fa1663f53">00129</a>         <a class="code" href="structOgre_1_1GLFBOManager_1_1FormatProperties.html" title="Frame Buffer Object properties for a certain texture format.">FormatProperties</a> mProps[<a class="code" href="group__Image.html#gga7e0353e7d36d4c2e8468641b7303d39ca44469cb753c29f07cba54678a57319a1">PF_COUNT</a>];
<a name="l00130"></a>00130         
<a name="l00135"></a><a class="code" href="structOgre_1_1GLFBOManager_1_1RBFormat.html">00135</a>         <span class="keyword">struct </span><a class="code" href="structOgre_1_1GLFBOManager_1_1RBFormat.html" title="Stencil and depth renderbuffers of the same format are re-used between surfaces of the same size and ...">RBFormat</a>
<a name="l00136"></a>00136         {
<a name="l00137"></a><a class="code" href="structOgre_1_1GLFBOManager_1_1RBFormat.html#a9a8b33c84217c07b63b582245c02ad06">00137</a>             <a class="code" href="structOgre_1_1GLFBOManager_1_1RBFormat.html" title="Stencil and depth renderbuffers of the same format are re-used between surfaces of the same size and ...">RBFormat</a>(GLenum inFormat, <span class="keywordtype">size_t</span> inWidth, <span class="keywordtype">size_t</span> inHeight, <a class="code" href="namespaceOgre.html#ab6e842a18caf062ed73a5d3badd0dd4c">uint</a> fsaa):
<a name="l00138"></a>00138                 format(inFormat), width(inWidth), height(inHeight), samples(fsaa)
<a name="l00139"></a>00139             {}
<a name="l00140"></a><a class="code" href="structOgre_1_1GLFBOManager_1_1RBFormat.html#aded84740b0039491b9b9ef952bae0424">00140</a>             GLenum <a class="code" href="structOgre_1_1GLFBOManager_1_1RBFormat.html#aded84740b0039491b9b9ef952bae0424">format</a>;
<a name="l00141"></a><a class="code" href="structOgre_1_1GLFBOManager_1_1RBFormat.html#aab71d4bc10eca58e35769b42d5f3fce6">00141</a>             <span class="keywordtype">size_t</span> <a class="code" href="structOgre_1_1GLFBOManager_1_1RBFormat.html#aab71d4bc10eca58e35769b42d5f3fce6">width</a>;
<a name="l00142"></a><a class="code" href="structOgre_1_1GLFBOManager_1_1RBFormat.html#aab72c84bbeba918c202257a78b3e1f83">00142</a>             <span class="keywordtype">size_t</span> <a class="code" href="structOgre_1_1GLFBOManager_1_1RBFormat.html#aab72c84bbeba918c202257a78b3e1f83">height</a>;
<a name="l00143"></a><a class="code" href="structOgre_1_1GLFBOManager_1_1RBFormat.html#a7c19291843960fc1d654a4107bd4b861">00143</a>             <a class="code" href="namespaceOgre.html#ab6e842a18caf062ed73a5d3badd0dd4c">uint</a> <a class="code" href="structOgre_1_1GLFBOManager_1_1RBFormat.html#a7c19291843960fc1d654a4107bd4b861">samples</a>;
<a name="l00144"></a>00144             <span class="comment">// Overloaded comparison operator for usage in map</span>
<a name="l00145"></a><a class="code" href="structOgre_1_1GLFBOManager_1_1RBFormat.html#ab7d4ccf764707dfc1ae2dc3f47807ba1">00145</a>             <span class="keywordtype">bool</span> <a class="code" href="group__General.html#gae1dbf4506ab2500da5ec4ef0b58cb2e1">operator &lt; </a>(<span class="keyword">const</span> <a class="code" href="structOgre_1_1GLFBOManager_1_1RBFormat.html" title="Stencil and depth renderbuffers of the same format are re-used between surfaces of the same size and ...">RBFormat</a> &amp;other)<span class="keyword"> const</span>
<a name="l00146"></a>00146 <span class="keyword">            </span>{
<a name="l00147"></a>00147                 <span class="keywordflow">if</span>(format &lt; other.<a class="code" href="structOgre_1_1GLFBOManager_1_1RBFormat.html#aded84740b0039491b9b9ef952bae0424">format</a>)
<a name="l00148"></a>00148                 {
<a name="l00149"></a>00149                     <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00150"></a>00150                 }
<a name="l00151"></a>00151                 <span class="keywordflow">else</span> <span class="keywordflow">if</span>(format == other.<a class="code" href="structOgre_1_1GLFBOManager_1_1RBFormat.html#aded84740b0039491b9b9ef952bae0424">format</a>)
<a name="l00152"></a>00152                 {
<a name="l00153"></a>00153                     <span class="keywordflow">if</span>(width &lt; other.<a class="code" href="structOgre_1_1GLFBOManager_1_1RBFormat.html#aab71d4bc10eca58e35769b42d5f3fce6">width</a>)
<a name="l00154"></a>00154                     {
<a name="l00155"></a>00155                         <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00156"></a>00156                     }
<a name="l00157"></a>00157                     <span class="keywordflow">else</span> <span class="keywordflow">if</span>(width == other.<a class="code" href="structOgre_1_1GLFBOManager_1_1RBFormat.html#aab71d4bc10eca58e35769b42d5f3fce6">width</a>)
<a name="l00158"></a>00158                     {
<a name="l00159"></a>00159                         <span class="keywordflow">if</span>(height &lt; other.<a class="code" href="structOgre_1_1GLFBOManager_1_1RBFormat.html#aab72c84bbeba918c202257a78b3e1f83">height</a>)
<a name="l00160"></a>00160                             <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00161"></a>00161                         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (height == other.<a class="code" href="structOgre_1_1GLFBOManager_1_1RBFormat.html#aab72c84bbeba918c202257a78b3e1f83">height</a>)
<a name="l00162"></a>00162                         {
<a name="l00163"></a>00163                             <span class="keywordflow">if</span> (samples &lt; other.<a class="code" href="structOgre_1_1GLFBOManager_1_1RBFormat.html#a7c19291843960fc1d654a4107bd4b861">samples</a>)
<a name="l00164"></a>00164                                 <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00165"></a>00165                         }
<a name="l00166"></a>00166                     }
<a name="l00167"></a>00167                 }
<a name="l00168"></a>00168                 <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00169"></a>00169             }
<a name="l00170"></a>00170         };
<a name="l00171"></a><a class="code" href="structOgre_1_1GLFBOManager_1_1RBRef.html">00171</a>         <span class="keyword">struct </span><a class="code" href="structOgre_1_1GLFBOManager_1_1RBRef.html">RBRef</a>
<a name="l00172"></a>00172         {
<a name="l00173"></a><a class="code" href="structOgre_1_1GLFBOManager_1_1RBRef.html#a08d65b853af86919c2b4a7df7ae01f10">00173</a>             <a class="code" href="structOgre_1_1GLFBOManager_1_1RBRef.html#a08d65b853af86919c2b4a7df7ae01f10">RBRef</a>(){}
<a name="l00174"></a><a class="code" href="structOgre_1_1GLFBOManager_1_1RBRef.html#affafe4cfc91ca61f4fc08ba2737a1a20">00174</a>             <a class="code" href="structOgre_1_1GLFBOManager_1_1RBRef.html">RBRef</a>(<a class="code" href="classOgre_1_1GLRenderBuffer.html" title="Renderbuffer surface.">GLRenderBuffer</a> *inBuffer):
<a name="l00175"></a>00175                 buffer(inBuffer), refcount(1)
<a name="l00176"></a>00176             { }
<a name="l00177"></a><a class="code" href="structOgre_1_1GLFBOManager_1_1RBRef.html#a18139b1b9ec00ea4c47218affba85cc3">00177</a>             <a class="code" href="classOgre_1_1GLRenderBuffer.html" title="Renderbuffer surface.">GLRenderBuffer</a> *<a class="code" href="structOgre_1_1GLFBOManager_1_1RBRef.html#a18139b1b9ec00ea4c47218affba85cc3">buffer</a>;
<a name="l00178"></a><a class="code" href="structOgre_1_1GLFBOManager_1_1RBRef.html#add5e2c937bbdfcc7e69949925a6541b2">00178</a>             <span class="keywordtype">size_t</span> <a class="code" href="structOgre_1_1GLFBOManager_1_1RBRef.html#add5e2c937bbdfcc7e69949925a6541b2">refcount</a>;
<a name="l00179"></a>00179         };
<a name="l00180"></a><a class="code" href="classOgre_1_1GLFBOManager.html#aa220ae983ae5d6e4ac784504d318c2cf">00180</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1map.html">map&lt;RBFormat, RBRef&gt;::type</a> <a class="code" href="classOgre_1_1GLFBOManager.html#aa220ae983ae5d6e4ac784504d318c2cf">RenderBufferMap</a>;
<a name="l00181"></a><a class="code" href="classOgre_1_1GLFBOManager.html#afc86de36017a02b7b4038c8124c7cf72">00181</a>         <a class="code" href="classOgre_1_1GLFBOManager.html#aa220ae983ae5d6e4ac784504d318c2cf">RenderBufferMap</a> <a class="code" href="classOgre_1_1GLFBOManager.html#afc86de36017a02b7b4038c8124c7cf72">mRenderBufferMap</a>;
<a name="l00182"></a>00182         <span class="comment">// map(format, sizex, sizey) -&gt; [GLSurface*,refcount]</span>
<a name="l00183"></a>00183         
<a name="l00186"></a><a class="code" href="classOgre_1_1GLFBOManager.html#ad0d411e6dcb1e0f64f7cef6c972a0c8b">00186</a>         GLuint <a class="code" href="classOgre_1_1GLFBOManager.html#ad0d411e6dcb1e0f64f7cef6c972a0c8b" title="Temporary FBO identifier.">mTempFBO</a>;
<a name="l00187"></a>00187         
<a name="l00189"></a><a class="code" href="classOgre_1_1GLFBOManager.html#ae684a84f3f8cd89ddca4062ca25e1374">00189</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1GLFBOManager.html#ae684a84f3f8cd89ddca4062ca25e1374" title="Buggy ATI driver?">mATIMode</a>;
<a name="l00190"></a>00190         
<a name="l00192"></a>00192         <span class="keywordtype">void</span> detectFBOFormats();
<a name="l00193"></a>00193         GLuint _tryFormat(GLenum depthFormat, GLenum stencilFormat);
<a name="l00194"></a>00194         <span class="keywordtype">bool</span> _tryPackedFormat(GLenum packedFormat);
<a name="l00195"></a>00195     };
<a name="l00196"></a>00196     
<a name="l00197"></a>00197 
<a name="l00198"></a>00198 }
<a name="l00199"></a>00199 
<a name="l00200"></a>00200 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:50
</p>
</body>
</html>
